/* $Id: PLOP_head.h,v 1.1 2014/09/23 14:10:09 rjs Exp $
 *
 * Wrapper code for the PLOP Objective-C binding
 *
 */

#import <Foundation/Foundation.h>
#import <Foundation/NSException.h>

// We use PLOP as a Objective-C class name, therefore hide the actual C struct
// name for PLOP usage with Objective-C.

typedef struct PLOP_s PLOP_objc;
#define PLOP PLOP_objc
#import "ploplib.h"
#undef  PLOP
    
        

@interface PLOPException : NSException
{
@private
    NSInteger _errnum;
    NSString *_apiname;
}

- (id) initWithErrmsg:(NSString *)errmsg errnum: (NSInteger) aErrnum apiname: (NSString *)aApiname;
- (NSInteger) get_errnum;
- (NSString *) get_apiname;
- (NSString *) get_errmsg;

@end

        
@interface PLOP : NSObject {
    PLOP_objc *_p;
}   
- (NSInteger) add_recipient: (NSString *) optlist;
- (void) close_document: (NSInteger) doc optlist: (NSString *) optlist;
- (NSString *) convert_to_unicode: (NSString *) inputformat inputstring: (NSData *) inputstring optlist: (NSString *) optlist;
- (NSInteger) create_document: (NSString *) filename optlist: (NSString *) optlist;
- (void) create_pvf: (NSString *) filename data: (NSData *) data optlist: (NSString *) optlist;
- (NSInteger) delete_pvf: (NSString *) filename;
- (NSString *) get_apiname;
- (NSData *) get_buffer;
- (NSString *) get_errmsg;
- (NSInteger) get_errnum;
- (double) info_pvf: (NSString *) filename keyword: (NSString *) keyword;
- (NSInteger) open_document: (NSString *) filename optlist: (NSString *) optlist;
- (double) pcos_get_number: (NSInteger) doc path: (NSString *) path;
- (NSData *) pcos_get_stream: (NSInteger) doc optlist: (NSString *) optlist path: (NSString *) path;
- (NSString *) pcos_get_string: (NSInteger) doc path: (NSString *) path;
- (NSInteger) prepare_signature: (NSString *) optlist;
- (void) set_option: (NSString *) optlist;
@end
